import java.util.LinkedList;
import java.util.Vector;

public class Mak {

	/**
	 * @param args
	 */
	//najde cilovy uzel pomoci nehoz se rekonstruuje cesta
	public static Node findSol(Node n) {
		  LinkedList mTree = new LinkedList();//tvori se pomoci nej strom
		  Vector visit = new Vector();//vsechny navstivene uzly
		  Vector goodNodes = new Vector();//navstivene a prinosne uzly
		  boolean finish=false;
		  mTree.add(n);
		  visit.add(n);
		  goodNodes.add(n);
		  while (!finish) {
			  Node node=(Node)mTree.removeFirst();
			  Vector succs=findChild(node);
			  if (succs.size()==1) {
				  if (isInclude(visit,(Node)succs.elementAt(0))) {
					  goodNodes.remove(node);
				  }
			  } 
			  for (int i=0; i<succs.size(); i++) {
				  Node succ=(Node)succs.elementAt(i);
				  if (!isInclude(visit,succ)) {
					  if (isGoalNode(succ)) {
						  n=succ;
						  finish=true;
					  }
					  mTree.add(succ);
					  visit.add(succ);
					  goodNodes.add(succ);
				  } 
			  }
		  }
		  System.out.println("---------------------------------");
		  System.out.println("Navstivene uzly");
		  System.out.println("---------------------------------");
		  for (int i=0; i<goodNodes.size(); i++) {
			 ((Node)goodNodes.elementAt(i)).Info();
		  }
		  return n;
	}
	
	//pridava nasledniky uzlu
	public static Vector findChild(Node n) {
		Vector succ = new Vector();
		if (n.boat==1) {
			Append(succ,new Node(n.misL-1,n.kanL,0,n.misR+1,n.kanR,n));
			Append(succ,new Node(n.misL-2,n.kanL,0,n.misR+2,n.kanR,n));
			Append(succ,new Node(n.misL,n.kanL-1,0,n.misR,n.kanR+1,n));
			Append(succ,new Node(n.misL,n.kanL-2,0,n.misR,n.kanR+2,n));
			Append(succ,new Node(n.misL-1,n.kanL-1,0,n.misR+1,n.kanR+1,n));
		} else {
			Append(succ,new Node(n.misL+1,n.kanL,1,n.misR-1,n.kanR,n));
			Append(succ,new Node(n.misL+2,n.kanL,1,n.misR-2,n.kanR,n));
			Append(succ,new Node(n.misL,n.kanL+1,1,n.misR,n.kanR-1,n));
			Append(succ,new Node(n.misL,n.kanL+2,1,n.misR,n.kanR-2,n));
			Append(succ,new Node(n.misL+1,n.kanL+1,1,n.misR-1,n.kanR-1,n));
		}
		return succ;
	}
	
	public static void Append(Vector v,Node n) {
		if (isValid(n)) {
			v.addElement(n);
		}	
	}
	
		public static boolean isInclude(Vector v,Node n) {
		Node pom;
		for (int i=0;i<v.size();i++) {
			pom=(Node)v.elementAt(i);
			if (pom.boat==n.boat && pom.kanL==n.kanL && 
					pom.kanR==n.kanR && pom.misL==n.misL && 
					pom.misR==n.misR) {
				return true;
			}
		}
		return false;
	}
	
	public static boolean isValid(Node n) {
		if (n.misR==0) 
		{	if ((n.misL>=n.kanL) && (n.misL>=0) && (n.kanR>=0) && 
				(n.kanL>=0))
				return true;
			else
				return false;
		}
		else
		{	if (n.misL==0) 
			{	if ((n.misR>=n.kanR) && (n.misR>=0) && 
					(n.kanR>=0) && (n.kanL>=0))
					return true;
				else
					return false;
			}
			else
			{	if ((n.misR>=n.kanR) && (n.misL>=n.kanL) &&
					(n.misR>=0) && (n.misL>=0) && 
					(n.kanR>=0) && (n.kanL>=0))
					return true;
				else
					return false;
			}
		}

	}
		
	public static boolean isGoalNode(Node n) {
		if (n.misL==0 && n.kanL==0 && n.boat==0 && n.misR==3 && n.kanR==3) {
			return true;
		}
		return false;
	}
		
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		Node startNode = new Node(3,3,1,0,0,null);
		Node sol=findSol(startNode);
		System.out.println("---------------------------------");
		System.out.println("Cesta");
		System.out.println("---------------------------------");
		sol.printPath();
	}
}
